﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Image_Processor
{
	class ProcessSequence
	{
		private List<ProcessMethod> processes = new List<ProcessMethod>();

		public ProcessSequence() { }

		public List<ProcessMethod> GetProcesses()
		{
			return processes;
		}

		public void AddProcess(ProcessMethod process)
		{
			processes.Add(process);
		}

		public void RemoveProcess(ProcessMethod process)
		{
			processes = processes.Where(proc => proc.name != process.name).ToList();
		}

		public void ModifyProcess(ProcessMethod process)
		{
			int index = -1;
			for (int i = 0; i < processes.Count(); i++)
			{
				if (process.name == processes[i].name)
				{
					index = i;
				}
			}
			if (index != -1)
			{
				processes[index] = process;
			}
			else
			{
				processes.Add(process);
			}
		}

		public void AddOrRemove(ProcessMethod process, bool add)
		{
			if (add)
			{
				processes.Add(process);
			}
			else
			{
				RemoveProcess(process);
			}
		}
	}
}
